#!/usr/bin/perl
###############################################################################
#    CD Backup - backup.pl
#
#    CD Backup for Webmin Module ver. 1.0
#    Copyright (C) 2000 by The Pretender <Sebastien J. Gross>
#    Bug reports to: s.gross@bigfoot.com
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#
###############################################################################

use CGI qw(:standard param);
do '../web-lib.pl';
require "../cron/cron-lib.pl";
&init_config();

#
# Backup routine
#
sub exec_backup
{
  my $restore= param("restore");
  my $sel_date = param("sel_date");
  my $last_change = param("last_change");
  my $backup_dir = param("backup_dir");
  my $exclude_dir = param("exclude_dir");
  my $archive_name = param("archive_name");
  my $ex_dirs= "./exclude.dir";

  &header($text{'backup_done'}, undef); 
  print "<hr>\n";


  if ($restore eq "backup")
  {
    # Setup vars
    if ($exclude_dir) { $de = " --exclude-from $ex_dirs"; }
    if ($sel_date)
    {
      # Update a backup
      $lc = " -mtime -$last_change ";
      $t = "-type";

      # As the `find' command can only retrive one type of file and can't exclude one
      # we have to make a backup for each type except directory

      print "<h3>$text{'backup_b'}</h3>\n";
      open (FILE, "find $backup_dir $t b $lc | tar cvfz $archive_name-b -T - $de 2>&1 |");
      while (<FILE>)
      {
        print "$_";
      }
      close FILE;

      print "<h3>$text{'backup_p'}</h3>\n";
      open (FILE, "find $backup_dir $t p $lc | tar cvfz $archive_name-p -T - $de 2>&1 |");
      while (<FILE>)
      {
        print "$_";
      }
      close FILE;

      print "<h3>$text{'backup_f'}</h3>\n";
      open (FILE, "find $backup_dir $t f $lc | tar cvfz $archive_name-f -T - $de 2>&1 |");
      while (<FILE>)
      {
        print "$_";
      }
      close FILE;

      print "<h3>$text{'backup_l'}</h3>\n";      
      open (FILE, "find $backup_dir $t l $lc | tar cvfz $archive_name-l -T - $de 2>&1 |");
      while (<FILE>)
      {
        print "$_";
      }
      close FILE;

      print "<h3>$text{'backup_c'}</h3>\n";
      open (FILE, "find $backup_dir $t c $lc | tar cvfz $archive_name-c -T - $de 2>&1 |");
      while (<FILE>)
      {
        print "$_";
      }
      close FILE;

      print "<h3>$text{'backup_s'}</h3>\n";
      open (FILE, "find $backup_dir $t s $lc | tar cvfz $archive_name-s -T - $de 2>&1 |");
    }
    else
    {
      # Full backup
      print "<h3>$text{'backup_all'}</h3>\n";
      open (FILE, "tar cvfz $archive_name $backup_dir $de |");
    }
  }
  else
  {
    # Restore
    print "<h3>$text{'backup_restore'}</h3>\n";
    open (FILE, "tar xvfz $archive_name -C /|");
  } 

  while (<FILE>)
  {
    print "$_";
  }
  close FILE;

  
  print "Exclude_dirs = $exclude_dirs<br>\n";

  print "<h3>$text{'backup_done_txt'}</h3>";
  print "<hr>\n";
  print "<hr>\n";

  print "$text{'main_title'} $text{'version'}<br>\n";
  print "<a href=\"mailto:$text{'author_mail'}\">Sbastien J. Gross</a> - <a href=\"http://$text{'author_site'}\">$text{'author_site'}</a> --- <a href=\"http://$text{'company_site'}\">$text{'company'}</a><br>\n";
  &footer("", $text{'return_main'});

  return 1;
}
