#!/usr/bin/perl -w
#
# test.cgi -- A CGI script for FileUpload module demonstration.
#	      Make sure FileUpload.pm has been installed before
#	      you start to test this script.
#	      This script reads input from "./form.html" file,
#	      it expects there is a file being uploaded with
#	      input field name, ufile.
#
# Simon Tneoh Chee-Boon tneohcb@pc.jaring.my
# 
# Copyright (c) 2000 Simon Tneoh Chee-Boon. All rights reserved.
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#

use lib qw(/network/test/webmin-0.84/gehrigal_file/);
use strict;
use vars qw($cgi $fu $sizewritten);

# Autoflush.
$| = 1;

# Print the HTTP header line.
# I am not using CGI->header here because I want to check if CGI
# version 2.46 or above is installed.
print "Content-Type: text/html\n\n";

# Make sure CGI version 2.46 or above is installed.
eval("use CGI 2.46 qw(-private_tempfiles :standard);");
(print("Error: $@"), exit(-1)) if $@;

# Make sure FileUpload is installed.
eval("use FileUpload;");
(print("Error: $@"), exit(-1)) if $@;

# Create CGI object.
$cgi = new CGI;

# Has any files been uploaded?
if (! $cgi->param('ufile')) {
  print <<__END__ERROR__;
<html>
<head><title>Error</title></head>
<body bgcolor='white'>
It seems like you have not selected any files yet.
Please try again.
</body>
</html>
__END__ERROR__
  exit(-1);
}

# Create the FileUpload object.
$fu = new FileUpload($cgi->param('ufile'));

# Print results.
print <<__END__HTML__;
<html>
<head>
<title>Upload Result</title>
</head>
<body bgcolor='white'>
<h2>Upload Result</h2>
[ <a href='./'>Back To Index</a> | 
<a href='./form.html'>Back To Demonstration Page</a> ]
<hr>
<blockquote>
<table border='1' width='80%' cellpadding='5'>
<tr>
  <th>Action</th>
  <th>Command</th>
  <th>Returns</th>
</tr>
<tr>
  <td align='left'>Save the file<br>
    (<font size='-2' color='red'>For security problem, we only demo save_as() 
    here.</font>)</td>
  <td><font face='Courier'>\$fu-&gt;save_as("./test.html")</font></td>
  <td><font face='Courier'>
__END__HTML__
# Try to save the uploaded file.
$sizewritten = -1;
if (!($sizewritten = $fu->save_as("./test.html"))) {
  print "Fail to save file: $!";
}
else {
  print $sizewritten."bytes written<br>\n";
}
print <<__END__HTML2__;
  </font></td>
</tr>
<tr>
  <td align='left'>Check the uploaded file</td>
  <td colspan='2'><a href='./test.html'>./test.html</a>
    (<font color='red'>Notice: Because this script always save the uploaded
    file to "./test.html", so you might see file that\'s uploaded by 
    others.</font>)
  </td>
</tr>
</table>

</blockquote>
<hr>
[ <a href='./'>Back To Index</a> | 
<a href='./form.html'>Back To Demonstration Page</a> ]
</body>
</html>

__END__HTML2__

# Done.
exit(0);
__END__

