#use Digest::MD5;
#use MIME::Base64;

# global variables

$conn = "";

# webmin stuff

do '../web-lib.pl';
&init_config ();

use Net::LDAP;
use Net::LDAP::Entry;
use Text::ParseWords;
use strict;
no strict "vars";


sub connect
{
    $conn = Net::LDAP->new($config{server}, port => $config{port});
    if (! $conn) {
        &header ("LDAP Users Admin Error", "", "intro", 1, 1);
        print "<P><B><I>Couldn't connect to LDAP server</I></B><P>";
    }
   elsif ($config{user} && $config{passwd}) {
	   $conn->bind($config{user},password => $config{passwd});
   } else {
        &header ("LDAP Users Admin Error", "", "intro", 1, 1);
        print "<P><B><I>Module not configured</I></B><P>";
   }
}

sub show_level
{
    # do not filter OU yet
    # should display the OU for each entry
    my ($search_dn, $method, $filter) = @_;

    my ($entry, $i,$max,$mesg);
    my (%list, $dn,@values,$el, @koloms,$key);
	@koloms = 
("associateddomain","creatorsname","createtimestamp","modifiersname","modifytimestamp");
                                      
	$mesg = $conn->search(base=>$search_dn,scope=>$method,filter=>$filter);
	$max = $mesg->count;
	for ($i = 0;$i < $max;$i++){
		$entry = $mesg->entry($i);
        	$dn = $entry->dn;
		foreach $key ($entry->attributes){
			@values = $entry->get_value($key);
			foreach $el (@values){
	  			push @{${$list{$dn}}{$key}}, $el;
	  		}
		}
	foreach $el (@koloms){
  		push ( @{${$list{$dn}}{$el}},"");
  	}
	}

	return %list;
}


sub parse_csv {
	return parse_line(",",0,$_[0]);
}

sub parse_nsv {
	return parse_line("\n",0,$_[0]);
}

sub parse_esv {
	return parse_line("=",0,$_[0]);
}

sub parse_asv {
	return parse_line("\x00",0,$_[0]);
}

sub parse_ssv {
	return parse_line(" ",0,$_[0]);
}

sub save_entries {
	my ($hash,$rdn,$method,$string,$key,$value,$entry,$i,$str,$max,$mesg,$ref);
	$hash = $_[0];
	$dn = $hash{"dn"}[0];
	$rdn = &getRDN($hash{"dn"}[0]);
        $method = 'sub';
	$mesg = $conn->search(base=>$dn,scope=>$method,filter=>'('. $rdn . ')');
	$max = $mesg->count;
	for ($i = 0;$i < $max;$i++){
		$entry = $mesg->entry($i);
	}
	foreach $key (keys %{$hash}){
		if ($key ne "dn") {
			$ref = \@{$hash{$key}};
			$entry->replace($key=>$ref);
		}
	}
	$mesg = $entry -> update($conn);
	$string = $mesg->error if $mesg->code;
return $string;		
}

sub delete_entries {
	my 
($hash,$rdn,$method,$string,$key,$value,$entry,$mesg,$max,$dn,%save,$el,@allval,@delval);
	$hash = $_[0];
	$dn = $hash{"dn"}[0];
	$rdn = &getRDN($hash{"dn"}[0]);
        $method = 'sub';
	$mesg = $conn->search(base=>$dn,scope=>$method,filter=>'('. $rdn . ')');
	$max = $mesg->count;
	for ($i = 0;$i < $max;$i++){
		$entry = $mesg->entry($i);
		foreach $attr ($entry->attributes){
			if (!exists $hash{$attr}){
				push @{$save{$attr}},$entry->get_value($attr);
			} else {
				@allval = $entry->get_value($attr);
				foreach $value (@{$hash{$attr}}){
					push @delval,$value;
				}
				if (scalar(@allval) > 1){ 
					@saveval = diff(\@allval, \@delval);
					foreach $el (@saveval){
						push @{$save{$attr}},$el;
					}
				} else {
					$delete = $attr;
				}
			}
		}
	}
	if (!$delete){
	foreach $key (keys %save){
		$ref = \@{$save{$key}};
		$entry->replace($key=>$ref);
	} 
	} else {
	$entry->delete($delete);
	}

	$mesg = $entry -> update($conn);
	$string = $mesg->error if $mesg->code;
return $string;		
}

sub delete_all {
my ($dn,$string,$entry,$method,$rdn,$max,$mesg);
	$dn = $_[0];
	$rdn = &getRDN($dn);
        $method = 'sub';
	$mesg = $conn->search(base=>$dn,scope=>$method,filter=>'('. $rdn . ')');
	$max = $mesg->count;
	for ($i = 0;$i < $max;$i++){
		$entry = $mesg->entry($i);
	}
	$conn->delete($entry);
	$mesg = $entry -> update($conn);
	$string = $mesg->error if $mesg->code;
return $string;		
}

sub diff {
	my ($a,$b) = @_;
	my (%seen,@ret,$item,$el);
	@seen{@{$b}} = ();
	foreach $item (@{$a}) {
		push (@ret, $item) unless exists $seen{$item};
	}
	return @ret;
}
sub clone_entry {
	my ($newdn,$olddn) = @_;
	my ($rdn,$newrdn,$entry,$newentry,$string,$mesg,$max,$ref,@arr,$attr);
	$rdn = &getRDN($olddn);
	$newrdn = &getRDN($newdn);
	$newentry = Net::LDAP::Entry->new;
	$newentry->dn($newdn);
	$mesg = $conn->search(base=>$olddn,scope=>$method,filter=>'('. $rdn . ')');
	$max = $mesg->count;
	for ($i = 0;$i < $max;$i++){
		$entry = $mesg->entry($i);
		foreach $attr ($entry->attributes){
			if ($attr eq &getRDNkey($rdn)) {
				$newentry->add(&getRDNkey($newrdn)=>&getRDNval($newrdn));
			} else {
				@arr = $entry->get_value($attr);
				$ref = \@arr;
				$newentry->add($attr=>$ref);
			}
		}	
	}
	$mesg = $newentry -> update($conn);
	$string = $mesg->error if $mesg->code;
	return $string;
}
sub go_back {
	my ($in,@parsed,$out,$ref);
	@parsed = &parse_csv($_[0]);
	$ref = \@parsed;
        for ($i = 1;$i <= $#$ref;$i++) {
        	if ($i != $#$ref) {	
        	$out = $out . @$ref->[$i] . "," ;
        	} else {
        	$out = $out . @$ref->[$i]  ;
		}        	
        }
        $out =~ s/\s//;
        return $out
}
sub getRDN {
        my (@arg);
        @arg = parse_csv($_[0]);
	$arg[0] =~ s/\s//; 
	return $arg[0];
}

sub getRDNkey {
        my (@arg);
        @arg = parse_esv($_[0]);
	$arg[0] =~ s/\s//; 
        return $arg[0];
}

sub getRDNval {
        my (@arg);
        @arg = parse_esv($_[0]);
	$arg[0] =~ s/\s//; 
        return $arg[1];
}

sub create_entry {
	my ($hash) = $_[0];
	my ($rdn,$newrdn,$newdn,$entry,%newentry,$string,$mesg,$key,$value,$top);
	$newdn = $hash->{"dn"}->[0];
	$newrdn = &getRDN($newdn);
	$string = "$rdnkey is not an attribute of the specfied objectclasses" if 
(!exists($hash{&getRDNkey($newrdn)}));
	$newentry = Net::LDAP::Entry->new;
	$newentry->dn($newdn);
	foreach $key (keys %{$hash}){
		if ($key eq "dn") {
			$newentry->add(&getRDNkey($newrdn)=>&getRDNval($newrdn));
		} else {
			for($j = 0; $j <= $#{$hash->{$key}}; $j++){
				$top = 1 if ($key eq "objectClass" && $hash->{$key}->[$j] eq "top");
				print FILE "val = " . $hash->{$key}->[$j] . "\n";
				$newentry->add($key=>$hash->{$key}->[$j]);
			}
		}
	}
	$newentry->add(objectClass=>'top') if !$top;
	print FILE "dn = " . $newentry->dn . "\n";
	$mesg = $newentry -> update($conn);
	$string = $mesg->error if $mesg->code;
	return $string;
}

sub get_schema {
	$filename = $_[0] ? $_[0] : "schema.conf";
	my (%hash,$requires,$allows,$line,@lines,@words,$key,$el);
	open (FILE,"< " . $filename) or $error = "File error";
	@lines = <FILE> ;
	foreach $line (@lines){
		if ($line =~ /[A-Za-z1-9]+/){ 
			if($line =~  m/[A-Za-z1-9]+\s[A-Za-z1-9]+/){
				$requires = 0;
				$allows = 0;
				@words = &parse_ssv($line);
				$key = $words[1];
			}
			if($line =~ m/requires/){
				$allows = 0;
				$requires = 1;
			}
			if ($line =~ m/allows/){
				$requires = 0;
				$allows = 1;
			}
			if ($requires && $line !~ m/requires/){
				$line =~ s/\t+//;
				$line =~ s/\s+//;
				$line =~ s/,//;
				push @{${$hash{$key}}{"required"}},$line;
			}
			if ($allows && $line !~ m/allows/) {
				$line =~ s/\t+//;
				$line =~ s/\s+//;
				$line =~ s/,//;
				push @{${$hash{$key}}{"allowed"}},$line;
			}
		}
	}
	close FILE;
	open (FILE,"> /home/ben/schema.debug");
	print FILE "error = $error\n";
	foreach $key (keys %hash) {
		foreach $value (@{${$hash{$key}}{"required"}}){
			print FILE "Objectclass = $key required = $value \n";
		}
		foreach $value (@{${$hash{$key}}{"allowed"}}){
			print FILE "Objectclass = $key allowed = $value \n";
		}
	}
	close FILE;
	return %hash;
}
sub add_objectclass {
	my $hash = $_[0];
	my ($error,$key,$value,$i);
	open (FILE,">> schema.conf") or $error = "File error";
	foreach $key (keys %{$hash}){
		print FILE "objectclass " . $key . "\n";
		if (exists(${$hash{$key}}{"required"})) {
			print FILE "\trequires\n";
			$i = 0;
			foreach $value (@{${$hash{$key}}{"required"}}){
				if ($i < $#{${$hash{$key}}{"required"}}){
					$nonull = "\t\t" . $value .",\n";
					$nonull =~ s/\x0d//;
					print FILE $nonull ;
					$i++;
				} else {
					print FILE "\t\t" . $value . "\n";
				}
			}
		}
		if (exists(${$hash{$key}}{"allowed"})) {
			print FILE "\tallows\n";
			$i = 0;
			foreach $value (@{${$hash{$key}}{"allowed"}}){
				if ($i < $#{${$hash{$key}}{"allowed"}}){
					$nonull = "\t\t" . $value .",\n";
					$nonull =~ s/\x0d//;
					print FILE $nonull ;
					$i++;
				} else {
					print FILE "\t\t" . $value . "\n";
				}
			}
		}
	}
	close FILE;
	return $error;
}
			

sub getkols {
my (@kols,%koloms,$kol);
	@kols = 
("associateddomain","creatorsname","createtimestamp","modifiersname","modifytimestamp");
	foreach $kol (@kols){  ${$koloms{$kol}} = "";}
        return %koloms
}

sub ifblank
{
        $out = $_[0] ? $_[0] : "&nbsp";
	$out = "&nbsp" if ($_[0] =~ m/^\s+$/);
	return $out;
}
        

