#use Digest::MD5;
#use MIME::Base64;

# global variables

$conn = "";

# webmin stuff

do '../web-lib.pl';
&init_config ();

use Net::LDAP;
use Net::LDAP::Entry;
use Text::ParseWords;
use locale;
use strict;
no strict "vars";


sub connect
{
    $conn = Net::LDAP->new($config{server}, port => $config{port}, async => 1);
    if (! $conn) {
        &header ("LDAP Users Admin Error", "", "intro", 1, 1);
        print "<P><B><I>Couldn't connect to LDAP server</I></B><P>";
    } else {
    $conn->bind($config{user},password => $config{passwd});
    } 
}

sub show_level
{
    # do not filter OU yet
    # should display the OU for each entry
    my ($search_dn, $method, $filter) = @_;

    my ($entry, $i,$max);
    my (%list, $dn,@values,$el, @koloms,$key);
	@koloms = ("associateddomain","member","creatorsname","createtimestamp","modifiersname","modifytimestamp");
                                      
	$mesg = $conn->search(base=>$search_dn,scope=>$method,filter=>$filter);
	$max = $mesg->count;
	for ($i = 0;$i < $max;$i++){
		$entry = $mesg->entry($i);
        	$dn = $entry->dn;
		foreach $key ($entry->attributes){
			@values = $entry->get_value($key);
			foreach $el (@values){
	  			push @{${$list{$dn}}{$key}}, $el;
	  		}
		}
		foreach $el (@koloms){
  			push ( @{${$list{$dn}}{$el}},"");
  		}
	}
	return %list;
}


sub parse_csv {
	return parse_line(",",0,$_[0]);
}

sub parse_mail {
	return parse_line("@",0,$_[0]);
}

sub parse_esv {
	return parse_line("=",0,$_[0]);
}

sub parse_dsv {
	return parse_line(":",0,$_[0]);
}

sub parse_asv {
	return parse_line("\x00",0,$_[0]);
}

sub parse_ssv {
	return parse_line(" ",0,$_[0]);
}

sub parse_nsv {
	return parse_line("\n",0,$_[0]);
}

sub parse_scalar {
	my (@arg);
	@arg = parse_line("/",0,$_[0]);
	$arg[0] =~ s/\s//; 
        return $arg[0];
}
sub save_entries {
	my ($hash,$rdn,$method,$string,$key,$value,$entry,$i,$str,$max,$mesg,$ref);
	$hash = $_[0];
	$dn = $hash{"dn"}[0];
	$rdn = &getRDN($hash{"dn"}[0]);
        $method = 'sub';
	$mesg = $conn->search(base=>$dn,scope=>$method,filter=>'('. $rdn . ')');
	$max = $mesg->count;
	for ($i = 0;$i < $max;$i++){
		$entry = $mesg->entry($i);
	}
	foreach $key (keys %{$hash}){
		if ($key ne "dn") {
			$ref = \@{$hash{$key}};
			foreach $el (@{$ref}){
			}
			$entry->replace($key=>$ref);
		}
	}
	$mesg = $entry -> update($conn);
	$string = $mesg->error if $mesg->code;
return $string;		
}

sub delete_entries {
	my ($hash,$rdn,$method,$string,$key,$value,$entry,$mesg,$max,$dn,%save,$el,@allval,@delval,$ref,$mesg);
	$hash = $_[0];
	$dn = $hash{"dn"}[0];
	$rdn = &getRDN($hash{"dn"}[0]);
        $method = 'sub';
	$mesg = $conn->search(base=>$dn,scope=>$method,filter=>'('. $rdn . ')');
	$max = $mesg->count;
	for ($i = 0;$i < $max;$i++){
		$entry = $mesg->entry($i);
		foreach $attr ($entry->attributes){
			if (!exists $hash{$attr}){
				push @{$save{$attr}},$entry->get_value($attr);
			} else {
				@allval = $entry->get_value($attr);
				foreach $value (@{$hash{$attr}}){
					push @delval,$value;
				}
				if (scalar(@allval) > 1 ) {
					@saveval = diff(\@allval, \@delval);
					foreach $el (@saveval){
						push @{$save{$attr}},$el;
					}
				} else {
					$delete = $attr;
					}
			}
		}
	}
	if (!$delete){
		foreach $key (keys %save){
			$ref = \@{$save{$key}};
			$entry->replace($key=>$ref);
		}
	} else {
		$entry->delete($delete);
	}
	$mesg =	$entry -> update($conn);
	$string = $mesg->error if $mesg->code;
return $string;		
}


sub delete_all {
my ($dn,$string,$entry,$method,$mesg,$rdn,$max);
	$dn = $_[0];
	$rdn = &getRDN($dn);
	$searchgroup = "memberuid=" . &getRDNval($rdn);
        $method = 'sub';
	$mesg = $conn->search(base=>$dn,scope=>$method,filter=>'('. $rdn . ')');
	$max = $mesg->count;
	for ($i = 0;$i < $max;$i++){
		$entry = $mesg->entry($i);
	}
	$conn->delete($entry);
	$group = $conn->search(base=>$config{base},scope=>$method,filter=>'('. $searchgroup . ')');
	$max = $group->count;
	for ($i = 0;$i < $max;$i++){
		@repl = ();
		$entry = $group->entry($i);
		if ($group && $entry->exists("memberuid")){
			foreach $attr ($entry->attributes){
				@save = $entry->get_value($attr) if ($attr eq "memberuid");
			}
			foreach $el (@save){
				push @repl,$el if ($el ne &getRDNval($rdn)); 
			}
			if (scalar(@repl)) {
				$ref=\@repl;
				$entry->replace(memberuid=>$ref);
			} else {
				$entry->delete("memberuid");
			}
			$err = $entry -> update($conn) ;
			$string = $err->error . ": delete user from groups error " . $err->code if $err->code;
		}
	}
return $string;		
}

sub assign_prim {
	my ($in,$dn) = @_;
	my ($entry,$rdn,$method,$mesg,$max,$groupentry,$userentry,$attr,$el,$string);
	$rdn = &getRDN($dn);
        $method = 'sub';
	$mesg = $conn->search(base=>$dn,scope=>$method,filter=>'('. $rdn . ')');
	$max = $mesg->count;
	for ($i = 0;$i < $max;$i++){
		$userentry = $mesg->entry($i);
	}
	$rdn = $in;
	$mesg = $conn->search(base=>$config{base},scope=>$method,filter=>'('. $rdn . ')');
	$max = $mesg->count;
	for ($i = 0;$i < $max;$i++){
		$groupentry = $mesg->entry($i);
	}
	if ($groupentry && $userentry){
		if ($groupentry->exists("gidnumber")){
			foreach $attr ($groupentry->attributes){
				if ($attr eq "gidnumber"){
					if ($userentry->exists("gidnumber")){
						foreach $el ($userentry->attributes){
							if ($el eq "gidnumber"){
								$userentry->replace($el=>$groupentry->get_value($attr));
							}
						}
					} else {
						$userentry->add(gidnumber=>$groupentry->get_value($attr));
					}
				}
			}
		} else {
			$string = "Specified group has no gidnumber";
		}
		$groupentry->add(memberuid=>&getRDNval(&getRDN($dn)));
	} else {
		$string = "no attributes found in specified group";
	}
	$mesg = $userentry -> update($conn);
	$string = $mesg->error if $mesg->code;
	$mesg = $groupentry -> update($conn);
	$string = $mesg->error if $mesg->code;
	return $string;
}

sub assign_sec {
	my ($arr,$dn) = @_;
	my ($el,$method,$mesg,$max,$entry,$attr,$string);
	foreach $el (@{$arr}){
	        $method = 'sub';
		$mesg = $conn->search(base=>$config{base},scope=>$method,filter=>'('. $el . ')');
		$max = $mesg->count;
		for ($i = 0;$i < $max;$i++){
			$entry = $mesg->entry($i);
		}
		$entry->add(memberuid=>&getRDNval(&getRDN($dn)));
		$mesg = $entry -> update($conn);
		if ($mesg->code){
			push @string,($entry->dn . ": " . $mesg->error) ;
		}
	}
	return @string;
}

sub create_user {
	my ($hash) = $_[0];
	my ($rdn,$newrdn,$newdn,$entry,%newentry,$string,$mesg,$key,$value,$rdnkey,$top);
	$newdn = $hash->{"dn"}->[0];
	$newrdn = &getRDN($newdn);
	%allusers = &show_level($config{usersdir},"one","objectclass=*");
	%allgroups = &show_level($config{groupdir},"one","objectclass=*");
	if (&getRDNkey($newrdn) eq get_most_common(\%allusers)) {
		$user = 1;
	}
	if (&getRDNkey($newrdn) eq get_most_common(\%allgroups)) {
		$group = 1;
	}                                                                                         
	$newentry = Net::LDAP::Entry->new;
	$newentry->dn($newdn);
	foreach $key (keys %{$hash}){
		if ($key ne "dn" && $key ne get_most_common(\%allusers) && $key ne get_most_common(\%allgroups)) {
			for($j = 0; $j <= $#{$hash->{$key}}; $j++){
				$top = 1 if ($key eq "objectClass" && $hash->{$key}->[$j] eq "top");
				if ($hash->{$key}->[$j] eq &getRDNkey($newrdn)) {
					$rdnkey = 1;
				}
				$newentry->add($key=>$hash->{$key}->[$j]);
			}
		}
	}
	$newentry->add(&getRDNkey($newrdn)=>&getRDNval($newrdn));
	$newentry->add(objectClass=>'top') if !$top;
	$newentry->add(objectClass=>'uidObject') if ($user && !$rdnkey);
	if ($group && !$rdnkey){
		$newentry->add(objectClass=>'posixGroup');
		$newentry->addValue(gidNumber=>' ');
	}
	$mesg = $newentry -> update($conn);
	$string = $mesg->error if $mesg->code;
	return $string;
}

sub clone_entry {
	my ($newdn,$olddn) = @_;
	my ($rdn,$newrdn,$entry,$newentry,$string,$mesg);
	$rdn = &getRDN($olddn);
	$newrdn = &getRDN($newdn);
	$newentry = Net::LDAP::Entry->new;
	$newentry->dn($newdn);
	$mesg = $conn->search(base=>$olddn,scope=>$method,filter=>'('. $rdn . ')');
	$max = $mesg->count;
	for ($i = 0;$i < $max;$i++){
		$entry = $mesg->entry($i);
		foreach $attr ($entry->attributes){
			$str = "";
			if ($attr eq &getRDNkey($rdn)) {
				$newentry->add(&getRDNkey($newrdn)=>&getRDNval($newrdn));
			} else {
				@arr = $entry->get_value($attr);
				$ref = \@arr;
				$newentry->add($attr=>$ref);
			}
		}	
	}
	$mesg = $newentry -> update($conn);
	$string = $mesg->error if $mesg->code;
	return $string;
}
sub go_back {
	my ($in,@parsed,$out,$ref);
	@parsed = &parse_csv($_[0]);
	$ref = \@parsed;
        for ($i = 1;$i <= $#$ref;$i++) {
        	if ($i != $#$ref) {	
        	$out = $out . @$ref->[$i] . "," ;
        	} else {
        	$out = $out . @$ref->[$i]  ;
		}        	
        }
        $out =~ s/\s//;
        return $out
}

sub diff {
	my ($a,$b) = @_;
	my (%seen,@ret,$item,$el);
	@seen{@{$b}} = ();
	foreach $item (@{$a}) {
		push (@ret, $item) unless exists $seen{$item};
	}
	return @ret;
}

sub getRDN {
        my (@arg);
        @arg = parse_csv($_[0]);
	$arg[0] =~ s/\s//; 
	return $arg[0];
}

sub getRDNkey {
        my (@arg);
        @arg = parse_esv($_[0]);
	$arg[0] =~ s/\s//; 
        return $arg[0];
}

sub getRDNval {
        my (@arg);
        @arg = parse_esv($_[0]);
	$arg[0] =~ s/\s//; 
        return $arg[1];
}

sub getLDIFkey {
        my (@arg);
        @arg = parse_dsv($_[0]);
	$arg[0] =~ s/\s//; 
	$arg[0] =~ s/\n//; 
        return $arg[0];
}

sub getLDIFval {
        my (@arg);
        @arg = parse_dsv($_[0]);
	$arg[1] =~ s/\s//; 
	$arg[1] =~ s/\n//; 
        return $arg[1];
}

sub getkols {
my (@kols,%koloms,$kol);
	@kols = ("associateddomain","member","creatorsname","createtimestamp","modifiersname","modifytimestamp");
	foreach $kol (@kols){  ${$koloms{$kol}} = "";}
        return %koloms
}

sub getkolsoc {
my (@kols,%koloms,$kol);
	@kols = ("objectclass","associateddomain","member","creatorsname","createtimestamp","modifiersname","modifytimestamp");
	foreach $kol (@kols){  ${$koloms{$kol}} = "";}
        return %koloms
}

sub get_most_common {
	my ($hash) = $_[0];
	my (%seen,$dn) ; 
	foreach $dn (keys %{$hash}){
		$rdnkey = &getRDNkey(&getRDN($dn));
		$seen{$rdnkey} = $seen{$rdnkey} + 1;
	}
	$prev = 0;
	foreach $el (keys %seen){
		if ($seen{$el} > $prev){
			$prev = $seen{$el};
			$out = $el;
		}
	}
return $out;
}

sub cn_no_spaces {
	my ($in) = $_[0];
	$in =~ s/\s/_/; 
	return $in;
}

sub cn_to_dn {
	my ($in) = $_[0];
	my (%users,%check,$common,@words,$out,$i,$lower);
	%users = &show_level($config{usersdir},"one","objectclass=*");
	$common = &get_most_common(\%users);
	@words = &parse_ssv($in);
	$i = 1;
	$lower = substr($words[1],0,1);
	%check = ( "1", 1);
	while (scalar(%check) && $lower ne $words[1] ) { 
		$lower = substr($words[1],0,$i);
		$out = "\u$words[0]" . "\u$lower";
		$i++;
		%check = &show_level($config{usersdir},"sub",$common . "=" . $out);
	}
	return $out;
}

sub get_sn {
	my ($in) = $_[0];
	my (@words);
	@words = &parse_ssv($in);
	return "\u$words[1]";
}

sub get_gn {
	my ($in) = $_[0];
	my (@words);
	@words = &parse_ssv($in);
	return "\u$words[0]";
}

sub get_initials {
	my ($in) = $_[0];
	my (@words,$out,$first,$second);
	@words = parse_ssv($in);
	$first = substr($words[0],0,1);
	$second = substr($words[1],0,1);
	$out = "\u$first" . "\u$second";
	return $out;
}

sub get_mail_domain {
	my ($in) = $_[0];
	my (@arr);
	@arr = parse_mail($in);
	return $arr[1];
}

sub ifblank
{
        $out = $_[0] ? $_[0] : "&nbsp";
        $out = "&nbsp" if ($_[0] =~ m/^\s+$/);
        return $out;
}

sub get_schema {
	$filename = $_[0] ? $_[0] : "schema.conf";
	my (%hash,$requires,$allows,$line,@lines,@words,$key,$el);
	open (FILE,"< " . $filename) or $error = "File error";
	@lines = <FILE> ;
	foreach $line (@lines){
		if ($line =~ /[A-Za-z1-9]+/){ 
			if($line =~  m/[A-Za-z1-9]+\s[A-Za-z1-9]+/){
				$requires = 0;
				$allows = 0;
				@words = &parse_ssv($line);
				$key = $words[1];
			}
			if($line =~ m/requires/){
				$allows = 0;
				$requires = 1;
			}
			if ($line =~ m/allows/){
				$requires = 0;
				$allows = 1;
			}
			if ($requires && $line !~ m/requires/){
				$line =~ s/\t+//;
				$line =~ s/\s+//;
				$line =~ s/,//;
				push @{${$hash{$key}}{"required"}},$line;
			}
			if ($allows && $line !~ m/allows/) {
				$line =~ s/\t+//;
				$line =~ s/\s+//;
				$line =~ s/,//;
				push @{${$hash{$key}}{"allowed"}},$line;
			}
		}
	}
	close FILE;
	return %hash;
}
		
sub add_objectclass {
	my $hash = $_[0];
	my ($error,$key,$value,$i);
	open (FILE,">> schema.conf") or $error = "File error";
	foreach $key (keys %{$hash}){
		print FILE "objectclass " . $key . "\n";
		if (exists(${$hash{$key}}{"required"})) {
			print FILE "\trequires\n";
			$i = 0;
			foreach $value (@{${$hash{$key}}{"required"}}){
				if ($i < $#{${$hash{$key}}{"required"}}){
					$nonull = "\t\t" . $value .",\n";
					$nonull =~ s/\x0d//;
					print FILE $nonull ;
					$i++;
				} else {
					print FILE "\t\t" . $value . "\n";
				}
			}
		}
		if (exists(${$hash{$key}}{"allowed"})) {
			print FILE "\tallows\n";
			$i = 0;
			foreach $value (@{${$hash{$key}}{"allowed"}}){
				if ($i < $#{${$hash{$key}}{"allowed"}}){
					$nonull = "\t\t" . $value .",\n";
					$nonull =~ s/\x0d//;
					print FILE $nonull ;
					$i++;
				} else {
					print FILE "\t\t" . $value . "\n";
				}
			}
		}
	}
	close FILE or $error = "File error";
	return $error;
}
			

