#!/usr/bin/perl
#	logview - a unix log file viewer
#	initially written by Alex Soldatoff (alx@centrobank.e-burg.ru),
#	fully rewritten by Eugene Borodin (eug@centrobank.e-burg.ru) 
#
#	v 0.77.1
#
#	This is free software.
#
#
require './logviewer-lib.pl';
%access=&get_module_acl();

# default inits
@sufText = ($text{'index_stxt1'}, $text{'index_stxt2'});
@suf     = ("",               ".0");
$defaultmode='static-last';
$in{'logSuf'} = "";
$in{'log'}    = "/var/adm/messages";
$logI         = 0;
$meta_http="<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$config{'refresh_interval'}, URL=/$module_name\">";
# ---------

&ReadParse();
$|=1;
@logs=();
@llist=split /,/, $config{'logs'};
@alist=split /,/, $access{'allowed_logs'};
@mlist=split /,/, $access{'modes'};
if($access{'allowed_logs'} ne "*") {
	my $i=0;
	foreach $log (@llist) {
        	foreach $allowed (@alist) {
                	if($log eq $allowed) {
				push @logs, $log;
				push @modes, $mlist[$i++];
				}
                	}
        	}
	}
else {
	@logs=@llist;
	@modes=@mlist;
	}
$nl=$#logs;	
if(++$nl == 0 ) { 
	push @logs,$text{'index_nothing'};
	}

$sufI = $in{'sufI'};
$logI = $in{'logI'};
$log  = "$logs[$logI]$suf[$sufI]";
$mode = $modes[$logI];
$smf="<form action=edit_modes.cgi> <input type=submit value=\"$text{'buttsm'}\"> </form>";
$href="<a name=start href=#end>$text{'index_gobott'}</a>\n";
#------------------------------------------------------------ 
&header("$text{'index_title'} $log", "", "intro", 1, 1, undef, 
	"$smf <br> $href\n",
		($mode eq 'refresh-all' or $mode eq 'refresh-last')? 
			($config{'refresh_interval'} ?
                                $meta_http : "" ) : "" );
print <<EOM; 
<hr>
<form action=\"#end\">
<input type=submit value=\"$text{'index_showbutton'}\">
<select name=logI>
EOM
for($i=0; $i <= $#logs; $i++) { 
	print "\t<option value=\"$i\" ",
		$logI == $i ? "selected" : "",
		" >$logs[$i]\n";
	}
print "</select>\n";

print <<EOM;
$text{'index_menufrom'}
<select name=sufI>
EOM
for($i=0; $i <= $#suf; $i++) { 
	print "\t<option value=\"$i\" ",
		$sufI == $i ? "selected" : "",
		" >$sufText[$i]\n";
	}
print "</select>\n";

print $text{'index_menumodes1'}," ", $log_modes{$mode},"\n";
print <<EOM;
$text{'index_menumodes2'}
</form>
<hr>\n
EOM

$fname=(split(/ |\|/,$logs[$logI]))[0];
$cmdflag=0;
if( -x $fname) {
	$cmdflag++;
	}

if($mode eq "live") {
	# lets do some tricks for controlling 
	# a non obedient children:
        # forking for mytail or respawner
        if (not  defined($cpid=open(LOG,"-|"))) {
                die "$text{'index_ecfr'}\n";
		} 
	elsif ($cpid) {
                # parent
		# forking again, for killer
      		if (not  defined($killer_cpid=fork())) {
       			die "$text{'index_ecfk'}\n";
       			}
       		elsif ($killer_cpid) {
			# parent
			# do display records
			goto DISPLAY;
			}
		else {
			# child
			&killer($cpid);
			} # fork killer
        	} # tail elsif 
	else {
                # child
		$|=1;
		if ($cmdflag) {
			&respawner($logs[$logI]) or
				&error("$text{'index_erropen'} $logs[$logI]: $!");
			}
		else {
			&mytail($log) or 
				&error("$text{'index_erropen'} $log: $!");
			}
		} # fork tail
	} # live mode
else {
	open(LOG, $cmdflag ? "$logs[$logI] |" : $log) or 
		&error("$text{'index_erropen'} ",
			$cmdflag ? $logs[$logI] : $log," : $!");
	# for Last records options
	if ($mode eq 'static-last' or $mode eq 'refresh-last') { 
		seek LOG, -$config{'last_bytes_to_display'}, 2; 
		<LOG> if not $cmdflag; # Skip uncompleted line
		}
	} # if live mode 

DISPLAY:
print "\n<pre>\n";
while(<LOG>) {
	print &html_escape($_);
	}
print "\n</pre>\n";

print <<EOM;
<a name=\"end\"></a>
<hr>
<div align=right>
	<a href=\"#start\">$text{'index_gotop'}</a>
</div>
<hr>
EOM

&footer("/", $text{'index_return'});

