#!/usr/bin/perl
#
# $Id: at.cgi,v 1.4 2000/12/17 19:52:30 seb Exp $
# Main screen for editing attributes
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
my ($file, $type, $suffix, $backends) = get_backends( $in{b}, $in{i} );
my $cbackend = $backends->[$in{b}];

error_setup( $text{at_save_error} );
error( $text{backend_denied} ) unless can_edit_backend( $in{b}, $in{i} );

print_header( $text{at_title}, $file, $type, $suffix );

print "<table width=100% border>\n";
print "<tr $tb><td><b>$text{at_name}</b></td><td><b>$text{at_alternates}</b></td>";
print "<td><b>$text{at_syntax}</b></td></tr>\n";

foreach $at ( sort keys %{$cbackend->{attribute}} ){
    $nb = $#{$cbackend->{attribute}{$at}};
    print "<tr $cb><td><a href=\"at_edit.cgi?b=$in{b}&i=$in{i}&at=$at\">$at</a></td>";
    print "<td>", $nb ? join( ' ', @{$cbackend->{attribute}{$at}}[0..$nb-1] ) : '&nbsp;', "</td>";
    print "<td>", $text{"at_$cbackend->{attribute}{$at}[$nb]"}, "</td></tr>\n";
}

print "</tr></table></td></tr></table><br>\n";

print "<hr><h3>$text{at_add_title}</h3>\n";
print "<form action=at_save.cgi method=post>\n";
print "<input type=hidden name=b value=$in{b}>\n";
print "<input type=hidden name=i value=$in{i}>\n";
print "<table border=0>\n";
print "<tr><td>$text{at_name}</td><td>$text{at_alternates}</td><td>$text{at_syntax}</td></tr>\n";
print "<tr><td><input name=at></td><td><input name=alternates></td><td>";
print list_input( 'syntax',
		  [ $text{at_bin}, $text{at_ces}, $text{at_cis}, $text{at_tel}, $text{at_dn} ],
		  [ 'bin',         'ces',         'cis',         'tel',         'dn' ],
		  'cis' );
print "</td></table><input type=submit name=add_at value=$text{at_add}></form><hr>\n";

if( $in{i} ){
    footer( "include_edit.cgi?b=$in{b}&i=$in{i}", $text{at_back} );
}
else {
    footer( $in{b} ? "backend.cgi?b=$in{b}" : "index.cgi", $text{at_back} );
}
