#!/usr/bin/perl
#
# $Id: access_edit.cgi,v 1.1 2002/01/21 23:39:59 seb Exp $
# Screen to edit access control
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
require './parse_slapd_conf.pl';
my @backends = parse_slapd_conf( $config{slapd_conf_file} );
my %cbackend = %{$backends[$in{b}]};

error_setup( $text{access_edit_error} );
error( $text{backend_denied} ) unless can_edit_backend( $in{b} );

sub print_who_access {
    my( $who, $access, $cwho ) = @_;

    my( $type, $val) = split( /=/, $who, 2);
    $val =~ s/\s*"?([^"]*)"?\s*/$1/;

    my $self = ($access =~ /^self/ ? 'checked' : '');
    $access =~ s/^self//;

    print "<td>", list_input( "who_$cwho",
			      [ $text{'access_type_*'},  $text{access_type_self},  $text{access_type_dn},
				$text{access_type_addr}, $text{access_type_domain}, $text{access_type_dnattr} ],
			      [ '*', 'self', 'dn', 'addr', 'domain', 'dnattr' ],
			      $type ), "</td>";
    print "<td><input size=40 value=\"$val\" name=val_$cwho>";
    print DN_chooser_button( "val_$cwho", 0, $cbackend{suffix} ), "</td>\n";

    print "<td><input type=checkbox name=\"self_$cwho\" $self value=self> $text{access_self}</td>\n";
    print "<td>", list_input( "access_$cwho",
			      [ $text{access_none}, $text{access_compare}, $text{access_search},
				$text{access_read}, $text{access_write} ],
			      [ 'none', 'compare', 'search', 'read', 'write' ],
			      $access ), "</td>";

    if( $who ){
	print "<td><input type=submit name=\"del_$cwho\" value=\"$text{access_remove}\"></td></tr>\n";
    }
    else {
	print "<td><input type=submit name=\"add_$cwho\" value=\"$text{access_add}\"></td></tr>\n";
    }
}

header( $text{index_title}, undef, undef, 1, undef, undef, $text{index_right} );
print "<center><b>$text{access_title} \"$cbackend{suffix}\" ($cbackend{type})";
print "</b></center><hr>\n";

print "<form method=post action=access_save.cgi>\n";
print "<input type=hidden name=b value=$in{b}>\n";
print "<input type=hidden name=access value=$in{a}>\n";
print "<input type=hidden name=nb_who value=", $#{$cbackend{access}[$in{a}]}, ">\n";
print "<table width=100% border>\n";
printf "<tr $tb><td><b>$text{access_to} %s</b></td></tr>\n", 
       join( ' ', ($cbackend{access}[$in{a}][0], $cbackend{access}[$in{a}][1]) );
print "<tr $cb><td><table width=100%>\n";

for( my $j=2; $j<$#{$cbackend{access}[$in{a}]}; $j+=2 ) {
    print_who_access( $cbackend{access}[$in{a}][$j], $cbackend{access}[$in{a}][$j+1], $j );
}

print_who_access( '', '', 'newwho' );

print "<tr><td colspan=5><hr>";
print "<input type=submit name=save_access value=\"$text{access_save}\">\n";
print "<input type=submit name=del_access value=\"$text{access_remove}\">\n";
print "</td></tr></table></td></tr></table></form><br>\n";

print "<hr>\n";
footer( "access.cgi?b=$in{b}", $text{access_edit_back} );
