#!/usr/bin/perl
#
# $Id: include_edit.cgi,v 1.1 2002/01/21 23:39:59 seb Exp $
# Screen to edit one included file
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
my ($file, $type, $suffix, $backends) = get_backends( $in{b} );
my $cbackend = $backends->[$in{b}];

error_setup( $text{include_edit_error} );
error( $text{backend_denied} ) unless can_edit_backend( $in{b}, $in{i} );

print_header( $text{include_edit_title}, $file, $type, $suffix );

print "<h2>$text{include_edit_file} $cbackend->{include}[$in{i}-1]</h2>\n";
&icons_table( [ "oc.cgi?b=$in{b}&i=$in{i}", "at.cgi?b=$in{b}&i=$in{i}" ]
            , [ $text{objectclass},         $text{attribut}            ]
            , [ 'images/oc.gif',            'images/at.gif'            ]
	    );
print "<hr>\n";

print "<form method=post action=include_save.cgi>\n";
print "<input type=hidden name=b value=$in{b}>\n";
print "<input type=hidden name=i value=$in{i}>\n";
print "<input type=submit name=del_include value=\"$text{include_delete}\">\n";
print "&nbsp;&nbsp;<input type=checkbox name=del_include_file> $text{include_delete_file}\n";
print "</form>\n";

print "<hr>\n";
footer( "include.cgi?b=$in{b}", $text{include_edit_back} );
