#!/usr/bin/perl

use strict;
use Data::Dumper;
require '../parse_slapd_conf.pl';

my $slapd_conf_file = "slapd_test.conf";

print "*** parse_slapd_conf\n";
my @slapd_conf = parse_slapd_conf( $slapd_conf_file );

$slapd_conf[0]{loglevel} = 99;
$slapd_conf[0]{include}[2] = "toto";

my %index;
$index{attrs} = [ 'default' ];
$index{types} = [ 'none' ];
push @{$slapd_conf[1]{index}}, \%index;

$slapd_conf[1]{access}{'attribute=userPassword'}{self} = 'compare';
my %acl = ( 'self' => 'write' );
$slapd_conf[1]{access}{'homePhone'} = \%acl;

print Dumper \@slapd_conf;

print "*** write_slapd_conf\n";
write_slapd_conf( $slapd_conf_file, \@slapd_conf );
