/*
 *    author: Lloyd Dupont
 *    mail: lloyd@galador.net
 *    Copyright (C) 2000 Lloyd Dupont
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * the window container to floating menu
 */
class MenuWindow extends Window
{
    public final static Frame sys_frame = new Frame();
    MenuPanel menu;

    public MenuWindow()
	{
        super(sys_frame);
        menu = new MenuPanel();
		setEnabled(true);

        // work around some bugs on some platform
        setBounds(100, 100, 10, 10);
        setLayout(new BorderLayout());
        add(menu, BorderLayout.CENTER);
	}
    public MenuPanel menu() { return menu; }
    public void configure(MenuPanel c, Object o, int i) {
        menu.setCommands(o);
        menu.setController(c.getController());

        Point p = c.getLocationOnScreen();
        Dimension d = c.getSize();
        Rectangle r = c.getCellRect(i);
        setLocation(p.x+d.width-1, p.y + r.y);
        pack();
        Dimension d2 = getSize();
        setSize(d.width, d2.height);
    }

    public void update(Graphics g) { paint(g); }
    public void paint(Graphics g) { menu.paint(g); }
}