/*
 *    author: Lloyd Dupont
 *    mail: lloyd@galador.net
 *    Copyright (C) 2000 Lloyd Dupont
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * an Icon displaying a triangle pointing right. a submenu indicator.
 *
 * @see Icon
 */
public class RightArrowIcon implements Icon
{
    Dimension size;

    public RightArrowIcon(int width, int height) {
        size = new Dimension(width, height);
    }
    public Dimension getSize() { return size; }
    public void paint(Graphics g, int x, int y) {
        int[] xp = new int[] {x, x, x + size.width};
        int[] yp = new int[] {y, y + size.height, y + size.height/2};
        g.setColor(Color.black);
        g.fillPolygon(xp, yp, 3);
    }
}