/*
 *    author: Lloyd Dupont
 *    mail: lloyd@galador.net
 *    Copyright (C) 2000 Lloyd Dupont
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;

/**
 * a static only set of method to find resource. should work well with
 * Netscape and IE. it use, for this a list of roots URL and class loader.
 * testing it one. To verify existance of object open stream on URL and read
 * 1 byte. It should be <B>a good idea</B> to init it with: <BR>
 * </I>URLBuilder.addURLPath(myApplet)</I>
 */
public class URLBuilder
{
	static Vector roots = new Vector();
	static Vector finders = new Vector();

	/**
	 * try to find a resource from it's name.
	 */
	public static URL find(String name) {
		Enumeration enum;
		URL url;

		enum = roots.elements();
		while(enum.hasMoreElements())
			try {
				url = (URL) enum.nextElement();
				url = new URL(url, name);

				// verify existence, any better idea ?
				InputStream is = url.openStream();
				is.read();
				is.close();
				return url;
			}
			catch(Exception ex) {}

		enum = finders.elements();
		while(enum.hasMoreElements()) {
			ClassLoader cl = (ClassLoader) enum.nextElement();
			url = cl.getResource(name);
			if(url != null)
				return url;
		}

		ClassLoader cl = URLBuilder.class.getClassLoader();
		return cl.getResource(name);
	}

	public static void addURLPath(Applet a) {
		roots.addElement(a.getDocumentBase());
		finders.addElement(a.getClass().getClassLoader());
	}
	public static void addURLPath(URL u) {
		roots.addElement(u);
	}
	public static void addURLPath(Class c) {
		finders.addElement(c.getClassLoader());
	}
	public static void addURLPath(ClassLoader cl) {
		finders.addElement(cl);
	}
}